Index: serefpolicy-contrib-20140730/virt.if
===================================================================
--- serefpolicy-contrib-20140730.orig/virt.if
+++ serefpolicy-contrib-20140730/virt.if
@@ -1,120 +1,51 @@
-## <summary>Libvirt virtualization API.</summary>
+## <summary>Libvirt virtualization API</summary>
 
-#######################################
+########################################
 ## <summary>
-##	The template to define a virt domain.
+##	Creates types and rules for a basic
+##	qemu process domain.
 ## </summary>
-## <param name="domain_prefix">
+## <param name="prefix">
 ##	<summary>
-##	Domain prefix to be used.
+##	Prefix for the domain.
 ##	</summary>
 ## </param>
 #
 template(`virt_domain_template',`
 	gen_require(`
-		attribute_role virt_domain_roles;
-		attribute virt_image_type, virt_domain, virt_tmpfs_type;
-		attribute virt_ptynode, virt_tmp_type;
+		attribute virt_image_type, virt_domain;
+		attribute virt_tmpfs_type;
+		attribute virt_ptynode;
+		type qemu_exec_t;
 	')
 
-	########################################
-	#
-	# Declarations
-	#
-
 	type $1_t, virt_domain;
-	application_type($1_t)
-	qemu_entry_type($1_t)
+	application_domain($1_t, qemu_exec_t)
 	domain_user_exemption_target($1_t)
 	mls_rangetrans_target($1_t)
 	mcs_constrained($1_t)
-	role virt_domain_roles types $1_t;
+	role system_r types $1_t;
 
 	type $1_devpts_t, virt_ptynode;
 	term_pty($1_devpts_t)
 
-	type $1_tmp_t, virt_tmp_type;
-	files_tmp_file($1_tmp_t)
-
-	type $1_tmpfs_t, virt_tmpfs_type;
-	files_tmpfs_file($1_tmpfs_t)
+	kernel_read_system_state($1_t)
 
-	optional_policy(`
-		pulseaudio_tmpfs_content($1_tmpfs_t)
-	')
+	auth_read_passwd($1_t)
 
-	type $1_image_t, virt_image_type;
-	files_type($1_image_t)
-	dev_node($1_image_t)
-	dev_associate_sysfs($1_image_t)
+	logging_send_syslog_msg($1_t)
 
-	########################################
-	#
-	# Policy
-	#
-
-	allow $1_t $1_devpts_t:chr_file { rw_term_perms setattr_chr_file_perms };
+	allow $1_t $1_devpts_t:chr_file { rw_chr_file_perms setattr_chr_file_perms };
 	term_create_pty($1_t, $1_devpts_t)
-
-	manage_dirs_pattern($1_t, $1_image_t, $1_image_t)
-	manage_files_pattern($1_t, $1_image_t, $1_image_t)
-	manage_fifo_files_pattern($1_t, $1_image_t, $1_image_t)
-	read_lnk_files_pattern($1_t, $1_image_t, $1_image_t)
-	manage_sock_files_pattern($1_t, $1_image_t, $1_image_t)
-	rw_chr_files_pattern($1_t, $1_image_t, $1_image_t)
-	rw_blk_files_pattern($1_t, $1_image_t, $1_image_t)
-	fs_hugetlbfs_filetrans($1_t, $1_image_t, file)
-
-	manage_dirs_pattern($1_t, $1_tmp_t, $1_tmp_t)
-	manage_files_pattern($1_t, $1_tmp_t, $1_tmp_t)
-	manage_lnk_files_pattern($1_t, $1_tmp_t, $1_tmp_t)
-	files_tmp_filetrans($1_t, $1_tmp_t, { file dir })
-
-	manage_dirs_pattern($1_t, $1_tmpfs_t, $1_tmpfs_t)
-	manage_files_pattern($1_t, $1_tmpfs_t, $1_tmpfs_t)
-	manage_lnk_files_pattern($1_t, $1_tmpfs_t, $1_tmpfs_t)
-	fs_tmpfs_filetrans($1_t, $1_tmpfs_t, { dir file lnk_file })
-
-	optional_policy(`
-		pulseaudio_run($1_t, virt_domain_roles)
-	')
-
-	optional_policy(`
-		xserver_rw_shm($1_t)
-	')
-')
-
-#######################################
-## <summary>
-##	The template to define a virt lxc domain.
-## </summary>
-## <param name="domain_prefix">
-##	<summary>
-##	Domain prefix to be used.
-##	</summary>
-## </param>
-#
-template(`virt_lxc_domain_template',`
-	gen_require(`
-		attribute_role svirt_lxc_domain_roles;
-		attribute svirt_lxc_domain;
-	')
-
-	type $1_t, svirt_lxc_domain;
-	domain_type($1_t)
-	domain_user_exemption_target($1_t)
-	mls_rangetrans_target($1_t)
-	mcs_constrained($1_t)
-	role svirt_lxc_domain_roles types $1_t;
 ')
 
 ########################################
 ## <summary>
-##	Make the specified type virt image type.
+##	Make the specified type usable as a virt image
 ## </summary>
 ## <param name="type">
 ##	<summary>
-##	Type to be used as a virtual image.
+##	Type to be used as a virtual image
 ##	</summary>
 ## </param>
 #
@@ -125,31 +56,32 @@ interface(`virt_image',`
 
 	typeattribute $1 virt_image_type;
 	files_type($1)
+
+	# virt images can be assigned to blk devices
 	dev_node($1)
 ')
 
-########################################
+#######################################
 ## <summary>
-##	Execute a domain transition to run virtd.
+##  Getattr on virt executable.
 ## </summary>
 ## <param name="domain">
-##	<summary>
-##	Domain allowed to transition.
-##	</summary>
+##  <summary>
+##  Domain allowed to transition.
+##  </summary>
 ## </param>
 #
-interface(`virt_domtrans',`
-	gen_require(`
-		type virtd_t, virtd_exec_t;
-	')
+interface(`virt_getattr_exec',`
+    gen_require(`
+        type virtd_exec_t;
+    ')
 
-	corecmd_search_bin($1)
-	domtrans_pattern($1, virtd_exec_t, virtd_t)
+	allow $1 virtd_exec_t:file getattr;
 ')
 
 ########################################
 ## <summary>
-##	Execute a domain transition to run virt qmf.
+##	Execute a domain transition to run virt.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -157,162 +89,71 @@ interface(`virt_domtrans',`
 ##	</summary>
 ## </param>
 #
-interface(`virt_domtrans_qmf',`
+interface(`virt_domtrans',`
 	gen_require(`
-		type virt_qmf_t, virt_qmf_exec_t;
+		type virtd_t, virtd_exec_t;
 	')
 
-	corecmd_search_bin($1)
-	domtrans_pattern($1, virt_qmf_exec_t, virt_qmf_t)
+	domtrans_pattern($1, virtd_exec_t, virtd_t)
 ')
 
 ########################################
 ## <summary>
-##	Execute a domain transition to
-##	run virt bridgehelper.
+##	Execute virtd in the caller domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed to transition.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
 #
-interface(`virt_domtrans_bridgehelper',`
+interface(`virt_exec',`
 	gen_require(`
-		type virt_bridgehelper_t, virt_bridgehelper_exec_t;
+		type virtd_exec_t;
 	')
 
-	corecmd_search_bin($1)
-	domtrans_pattern($1, virt_bridgehelper_exec_t, virt_bridgehelper_t)
+	can_exec($1, virtd_exec_t)
 ')
 
 ########################################
 ## <summary>
-##	Execute bridgehelper in the bridgehelper
-##	domain, and allow the specified role
-##	the bridgehelper domain.
+##	Transition to virt_qmf.
 ## </summary>
 ## <param name="domain">
-##	<summary>
-##	Domain allowed to transition.
-##	</summary>
-## </param>
-## <param name="role">
-##	<summary>
-##	Role allowed access.
-##	</summary>
-## </param>
-#
-interface(`virt_run_bridgehelper',`
-	gen_require(`
-		attribute_role virt_bridgehelper_roles;
-	')
-
-	virt_domtrans_bridgehelper($1)
-	roleattribute $2 virt_bridgehelper_roles;
-')
-
-########################################
 ## <summary>
-##	Execute virt domain in the their
-##	domain, and allow the specified
-##	role that virt domain.
-## </summary>
-## <param name="domain">
-##	<summary>
 ##	Domain allowed to transition.
-##	</summary>
-## </param>
-## <param name="role">
-##	<summary>
-##	Role allowed access.
-##	</summary>
-## </param>
-#
-interface(`virt_run_virt_domain',`
-	gen_require(`
-		attribute virt_domain;
-		attribute_role virt_domain_roles;
-	')
-
-	allow $1 virt_domain:process { signal transition };
-	roleattribute $2 virt_domain_roles;
-
-	allow virt_domain $1:fd use;
-	allow virt_domain $1:fifo_file rw_fifo_file_perms;
-	allow virt_domain $1:process sigchld;
-')
-
-########################################
-## <summary>
-##	Send generic signals to all virt domains.
 ## </summary>
-## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
 ## </param>
 #
-interface(`virt_signal_all_virt_domains',`
+interface(`virt_domtrans_qmf',`
 	gen_require(`
-		attribute virt_domain;
+		type virt_qmf_t, virt_qmf_exec_t;
 	')
 
-	allow $1 virt_domain:process signal;
+	corecmd_search_bin($1)
+	domtrans_pattern($1, virt_qmf_exec_t, virt_qmf_t)
 ')
 
 ########################################
 ## <summary>
-##	Send kill signals to all virt domains.
+##  Transition to virt_bridgehelper.
 ## </summary>
 ## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
-## </param>
-#
-interface(`virt_kill_all_virt_domains',`
-	gen_require(`
-		attribute virt_domain;
-	')
-
-	allow $1 virt_domain:process sigkill;
-')
-
-########################################
 ## <summary>
-##	Execute svirt lxc domains in their
-##	domain, and allow the specified
-##	role that svirt lxc domain.
+##  Domain allowed to transition.
 ## </summary>
-## <param name="domain">
-##	<summary>
-##	Domain allowed to transition.
-##	</summary>
-## </param>
-## <param name="role">
-##	<summary>
-##	Role allowed access.
-##	</summary>
 ## </param>
-#
-interface(`virt_run_svirt_lxc_domain',`
+interface(`virt_domtrans_bridgehelper',`
 	gen_require(`
-		attribute svirt_lxc_domain;
-		attribute_role svirt_lxc_domain_roles;
+		type virt_bridgehelper_t, virt_bridgehelper_exec_t;
 	')
 
-	allow $1 svirt_lxc_domain:process { signal transition };
-	roleattribute $2 svirt_lxc_domain_roles;
-
-	allow svirt_lxc_domain $1:fd use;
-	allow svirt_lxc_domain $1:fifo_file rw_fifo_file_perms;
-	allow svirt_lxc_domain $1:process sigchld;
+	domtrans_pattern($1, virt_bridgehelper_exec_t, virt_bridgehelper_t)
 ')
 
 #######################################
 ## <summary>
-##	Get attributes of virtd executable files.
+##	Connect to virt over a unix domain stream socket.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -320,18 +161,18 @@ interface(`virt_run_svirt_lxc_domain',`
 ##	</summary>
 ## </param>
 #
-interface(`virt_getattr_virtd_exec_files',`
+interface(`virt_stream_connect',`
 	gen_require(`
-		type virtd_exec_t;
+		type virtd_t, virt_var_run_t;
 	')
 
-	allow $1 virtd_exec_t:file getattr_file_perms;
+	files_search_pids($1)
+	stream_connect_pattern($1, virt_var_run_t, virt_var_run_t, virtd_t)
 ')
 
 #######################################
 ## <summary>
-##	Connect to virt with a unix
-##	domain stream socket.
+##	Connect to svirt process over a unix domain stream socket.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -339,18 +180,17 @@ interface(`virt_getattr_virtd_exec_files
 ##	</summary>
 ## </param>
 #
-interface(`virt_stream_connect',`
+interface(`virt_stream_connect_svirt',`
 	gen_require(`
-		type virtd_t, virt_var_run_t;
+		type svirt_t;
 	')
 
-	files_search_pids($1)
-	stream_connect_pattern($1, virt_var_run_t, virt_var_run_t, virtd_t)
+    allow $1 svirt_t:unix_stream_socket connectto;
 ')
 
 ########################################
 ## <summary>
-##	Attach to virt tun devices.
+##	Allow domain to attach to virt TUN devices
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -369,7 +209,7 @@ interface(`virt_attach_tun_iface',`
 
 ########################################
 ## <summary>
-##	Read virt configuration content.
+##	Read virt config files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -383,7 +223,6 @@ interface(`virt_read_config',`
 	')
 
 	files_search_etc($1)
-	allow $1 { virt_etc_t virt_etc_rw_t }:dir list_dir_perms;
 	read_files_pattern($1, virt_etc_t, virt_etc_t)
 	read_files_pattern($1, virt_etc_rw_t, virt_etc_rw_t)
 	read_lnk_files_pattern($1, virt_etc_rw_t, virt_etc_rw_t)
@@ -391,8 +230,7 @@ interface(`virt_read_config',`
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	virt configuration content.
+##	manage virt config files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -406,7 +244,6 @@ interface(`virt_manage_config',`
 	')
 
 	files_search_etc($1)
-	allow $1 { virt_etc_t virt_etc_rw_t }:dir manage_dir_perms;
 	manage_files_pattern($1, virt_etc_t, virt_etc_t)
 	manage_files_pattern($1, virt_etc_rw_t, virt_etc_rw_t)
 	manage_lnk_files_pattern($1, virt_etc_rw_t, virt_etc_rw_t)
@@ -414,8 +251,25 @@ interface(`virt_manage_config',`
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	virt image files.
+##	Allow domain to manage virt image files
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`virt_getattr_content',`
+	gen_require(`
+		type virt_content_t;
+	')
+
+    allow $1 virt_content_t:file getattr_file_perms;
+')
+
+########################################
+## <summary>
+##	Allow domain to manage virt image files
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -450,8 +304,7 @@ interface(`virt_read_content',`
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	virt content.
+##	Allow domain to write virt image files
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -459,35 +312,17 @@ interface(`virt_read_content',`
 ##	</summary>
 ## </param>
 #
-interface(`virt_manage_virt_content',`
+interface(`virt_write_content',`
 	gen_require(`
 		type virt_content_t;
 	')
 
-	userdom_search_user_home_dirs($1)
-	allow $1 virt_content_t:dir manage_dir_perms;
-	allow $1 virt_content_t:file manage_file_perms;
-	allow $1 virt_content_t:fifo_file manage_fifo_file_perms;
-	allow $1 virt_content_t:lnk_file manage_lnk_file_perms;
-	allow $1 virt_content_t:sock_file manage_sock_file_perms;
-	allow $1 virt_content_t:blk_file manage_blk_file_perms;
-
-	tunable_policy(`virt_use_nfs',`
-		fs_manage_nfs_dirs($1)
-		fs_manage_nfs_files($1)
-		fs_manage_nfs_symlinks($1)
-	')
-
-	tunable_policy(`virt_use_samba',`
-		fs_manage_cifs_dirs($1)
-		fs_manage_cifs_files($1)
-		fs_manage_cifs_symlinks($1)
-	')
+	allow $1 virt_content_t:file write_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Relabel virt content.
+##	Read virt PID symlinks files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -495,53 +330,37 @@ interface(`virt_manage_virt_content',`
 ##	</summary>
 ## </param>
 #
-interface(`virt_relabel_virt_content',`
+interface(`virt_read_pid_symlinks',`
 	gen_require(`
-		type virt_content_t;
+		type virt_var_run_t;
 	')
 
-	userdom_search_user_home_dirs($1)
-	allow $1 virt_content_t:dir relabel_dir_perms;
-	allow $1 virt_content_t:file relabel_file_perms;
-	allow $1 virt_content_t:fifo_file relabel_fifo_file_perms;
-	allow $1 virt_content_t:lnk_file relabel_lnk_file_perms;
-	allow $1 virt_content_t:sock_file relabel_sock_file_perms;
-	allow $1 virt_content_t:blk_file relabel_blk_file_perms;
+	files_search_pids($1)
+	read_lnk_files_pattern($1, virt_var_run_t, virt_var_run_t)
 ')
 
 ########################################
 ## <summary>
-##	Create specified objects in user home
-##	directories with the virt content type.
+##	Read virt PID files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="object_class">
-##	<summary>
-##	Class of the object being created.
-##	</summary>
-## </param>
-## <param name="name" optional="true">
-##	<summary>
-##	The name of the object being created.
-##	</summary>
-## </param>
 #
-interface(`virt_home_filetrans_virt_content',`
+interface(`virt_read_pid_files',`
 	gen_require(`
-		type virt_content_t;
+		type virt_var_run_t;
 	')
 
-	virt_home_filetrans($1, virt_content_t, $2, $3)
+	files_search_pids($1)
+	read_files_pattern($1, virt_var_run_t, virt_var_run_t)
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	svirt home content.
+##	Manage virt pid directories.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -549,34 +368,21 @@ interface(`virt_home_filetrans_virt_cont
 ##	</summary>
 ## </param>
 #
-interface(`virt_manage_svirt_home_content',`
+interface(`virt_manage_pid_dirs',`
 	gen_require(`
-		type svirt_home_t;
-	')
-
-	userdom_search_user_home_dirs($1)
-	allow $1 svirt_home_t:dir manage_dir_perms;
-	allow $1 svirt_home_t:file manage_file_perms;
-	allow $1 svirt_home_t:fifo_file manage_fifo_file_perms;
-	allow $1 svirt_home_t:lnk_file manage_lnk_file_perms;
-	allow $1 svirt_home_t:sock_file manage_sock_file_perms;
-
-	tunable_policy(`virt_use_nfs',`
-		fs_manage_nfs_dirs($1)
-		fs_manage_nfs_files($1)
-		fs_manage_nfs_symlinks($1)
+		type virt_var_run_t;
+		type virt_lxc_var_run_t;
 	')
 
-	tunable_policy(`virt_use_samba',`
-		fs_manage_cifs_dirs($1)
-		fs_manage_cifs_files($1)
-		fs_manage_cifs_symlinks($1)
-	')
+	files_search_pids($1)
+	manage_dirs_pattern($1, virt_var_run_t, virt_var_run_t)
+	manage_dirs_pattern($1, virt_lxc_var_run_t, virt_lxc_var_run_t)
+	virt_filetrans_named_content($1)
 ')
 
 ########################################
 ## <summary>
-##	Relabel svirt home content.
+##	Manage virt pid files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -584,32 +390,36 @@ interface(`virt_manage_svirt_home_conten
 ##	</summary>
 ## </param>
 #
-interface(`virt_relabel_svirt_home_content',`
+interface(`virt_manage_pid_files',`
 	gen_require(`
-		type svirt_home_t;
+		type virt_var_run_t;
+		type virt_lxc_var_run_t;
 	')
 
-	userdom_search_user_home_dirs($1)
-	allow $1 svirt_home_t:dir relabel_dir_perms;
-	allow $1 svirt_home_t:file relabel_file_perms;
-	allow $1 svirt_home_t:fifo_file relabel_fifo_file_perms;
-	allow $1 svirt_home_t:lnk_file relabel_lnk_file_perms;
-	allow $1 svirt_home_t:sock_file relabel_sock_file_perms;
+	files_search_pids($1)
+	manage_files_pattern($1, virt_var_run_t, virt_var_run_t)
+	manage_files_pattern($1, virt_lxc_var_run_t, virt_lxc_var_run_t)
 ')
 
 ########################################
 ## <summary>
-##	Create specified objects in user home
-##	directories with the svirt home type.
+##	Create objects in the pid directory
+##	with a private type with a type transition.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="object_class">
+## <param name="file">
+##	<summary>
+##	Type to which the created node will be transitioned.
+##	</summary>
+## </param>
+## <param name="class">
 ##	<summary>
-##	Class of the object being created.
+##	Object class(es) (single or set including {}) for which this
+##	the transition will occur.
 ##	</summary>
 ## </param>
 ## <param name="name" optional="true">
@@ -618,54 +428,36 @@ interface(`virt_relabel_svirt_home_conte
 ##	</summary>
 ## </param>
 #
-interface(`virt_home_filetrans_svirt_home',`
+interface(`virt_pid_filetrans',`
 	gen_require(`
-		type svirt_home_t;
+		type virt_var_run_t;
 	')
 
-	virt_home_filetrans($1, svirt_home_t, $2, $3)
+	filetrans_pattern($1, virt_var_run_t, $2, $3, $4)
 ')
 
 ########################################
 ## <summary>
-##	Create specified objects in generic
-##	virt home directories with private
-##	home type.
+##	Search virt lib directories.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="private_type">
-##	<summary>
-##	Private file type.
-##	</summary>
-## </param>
-## <param name="object_class">
-##	<summary>
-##	Class of the object being created.
-##	</summary>
-## </param>
-## <param name="name" optional="true">
-##	<summary>
-##	The name of the object being created.
-##	</summary>
-## </param>
 #
-interface(`virt_home_filetrans',`
+interface(`virt_search_lib',`
 	gen_require(`
-		type virt_home_t;
+		type virt_var_lib_t;
 	')
 
-	userdom_search_user_home_dirs($1)
-	filetrans_pattern($1, virt_home_t, $2, $3, $4)
+	allow $1 virt_var_lib_t:dir search_dir_perms;
+	files_search_var_lib($1)
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	virt home files.
+##	Read virt lib files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -673,54 +465,38 @@ interface(`virt_home_filetrans',`
 ##	</summary>
 ## </param>
 #
-interface(`virt_manage_home_files',`
+interface(`virt_read_lib_files',`
 	gen_require(`
-		type virt_home_t;
+		type virt_var_lib_t;
 	')
 
-	userdom_search_user_home_dirs($1)
-	manage_files_pattern($1, virt_home_t, virt_home_t)
+	files_search_var_lib($1)
+	read_files_pattern($1, virt_var_lib_t, virt_var_lib_t)
+	read_lnk_files_pattern($1, virt_var_lib_t, virt_var_lib_t)
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	virt home content.
+##	Dontaudit inherited read virt lib files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
+##	Domain to not audit.
 ##	</summary>
 ## </param>
 #
-interface(`virt_manage_generic_virt_home_content',`
+interface(`virt_dontaudit_read_lib_files',`
 	gen_require(`
-		type virt_home_t;
-	')
-
-	userdom_search_user_home_dirs($1)
-	allow $1 virt_home_t:dir manage_dir_perms;
-	allow $1 virt_home_t:file manage_file_perms;
-	allow $1 virt_home_t:fifo_file manage_fifo_file_perms;
-	allow $1 virt_home_t:lnk_file manage_lnk_file_perms;
-	allow $1 virt_home_t:sock_file manage_sock_file_perms;
-
-	tunable_policy(`virt_use_nfs',`
-		fs_manage_nfs_dirs($1)
-		fs_manage_nfs_files($1)
-		fs_manage_nfs_symlinks($1)
+		type virt_var_lib_t;
 	')
 
-	tunable_policy(`virt_use_samba',`
-		fs_manage_cifs_dirs($1)
-		fs_manage_cifs_files($1)
-		fs_manage_cifs_symlinks($1)
-	')
+	dontaudit $1 virt_var_lib_t:file read_inherited_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Relabel virt home content.
+##	Create, read, write, and delete
+##	virt lib files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -728,52 +504,58 @@ interface(`virt_manage_generic_virt_home
 ##	</summary>
 ## </param>
 #
-interface(`virt_relabel_generic_virt_home_content',`
+interface(`virt_manage_lib_files',`
 	gen_require(`
-		type virt_home_t;
+		type virt_var_lib_t;
 	')
 
-	userdom_search_user_home_dirs($1)
-	allow $1 virt_home_t:dir relabel_dir_perms;
-	allow $1 virt_home_t:file relabel_file_perms;
-	allow $1 virt_home_t:fifo_file relabel_fifo_file_perms;
-	allow $1 virt_home_t:lnk_file relabel_lnk_file_perms;
-	allow $1 virt_home_t:sock_file relabel_sock_file_perms;
+	files_search_var_lib($1)
+	manage_files_pattern($1, virt_var_lib_t, virt_var_lib_t)
 ')
 
 ########################################
 ## <summary>
-##	Create specified objects in user home
-##	directories with the generic virt
-##	home type.
+##	Allow the specified domain to read virt's log files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="object_class">
-##	<summary>
-##	Class of the object being created.
-##	</summary>
-## </param>
-## <param name="name" optional="true">
+## <rolecap/>
+#
+interface(`virt_read_log',`
+	gen_require(`
+		type virt_log_t;
+	')
+
+	logging_search_logs($1)
+	read_files_pattern($1, virt_log_t, virt_log_t)
+')
+
+########################################
+## <summary>
+##	Allow the specified domain to append
+##	virt log files.
+## </summary>
+## <param name="domain">
 ##	<summary>
-##	The name of the object being created.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
 #
-interface(`virt_home_filetrans_virt_home',`
+interface(`virt_append_log',`
 	gen_require(`
-		type virt_home_t;
+		type virt_log_t;
 	')
 
-	userdom_user_home_dir_filetrans($1, virt_home_t, $2, $3)
+	logging_search_logs($1)
+	append_files_pattern($1, virt_log_t, virt_log_t)
 ')
 
 ########################################
 ## <summary>
-##	Read virt pid files.
+##	Allow domain to manage virt log files
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -781,19 +563,19 @@ interface(`virt_home_filetrans_virt_home
 ##	</summary>
 ## </param>
 #
-interface(`virt_read_pid_files',`
+interface(`virt_manage_log',`
 	gen_require(`
-		type virt_var_run_t;
+		type virt_log_t;
 	')
 
-	files_search_pids($1)
-	read_files_pattern($1, virt_var_run_t, virt_var_run_t)
+	manage_dirs_pattern($1, virt_log_t, virt_log_t)
+	manage_files_pattern($1, virt_log_t, virt_log_t)
+	manage_lnk_files_pattern($1, virt_log_t, virt_log_t)
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	virt pid files.
+##	Allow domain to getattr virt image direcories
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -801,18 +583,18 @@ interface(`virt_read_pid_files',`
 ##	</summary>
 ## </param>
 #
-interface(`virt_manage_pid_files',`
+interface(`virt_getattr_images',`
 	gen_require(`
-		type virt_var_run_t;
+		attribute virt_image_type;
 	')
 
-	files_search_pids($1)
-	manage_files_pattern($1, virt_var_run_t, virt_var_run_t)
+	virt_search_lib($1)
+	allow $1 virt_image_type:file getattr_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Search virt lib directories.
+##	Allow domain to search virt image direcories
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -820,18 +602,18 @@ interface(`virt_manage_pid_files',`
 ##	</summary>
 ## </param>
 #
-interface(`virt_search_lib',`
+interface(`virt_search_images',`
 	gen_require(`
-		type virt_var_lib_t;
+		attribute virt_image_type;
 	')
 
-	files_search_var_lib($1)
-	allow $1 virt_var_lib_t:dir search_dir_perms;
+	virt_search_lib($1)
+	allow $1 virt_image_type:dir search_dir_perms;
 ')
 
 ########################################
 ## <summary>
-##	Read virt lib files.
+##	Allow domain to read virt image files
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -839,20 +621,73 @@ interface(`virt_search_lib',`
 ##	</summary>
 ## </param>
 #
-interface(`virt_read_lib_files',`
+interface(`virt_read_images',`
 	gen_require(`
 		type virt_var_lib_t;
+		attribute virt_image_type;
 	')
 
-	files_search_var_lib($1)
-	read_files_pattern($1, virt_var_lib_t, virt_var_lib_t)
-	read_lnk_files_pattern($1, virt_var_lib_t, virt_var_lib_t)
+	virt_search_lib($1)
+	allow $1 virt_image_type:dir list_dir_perms;
+	list_dirs_pattern($1, virt_image_type, virt_image_type)
+	read_files_pattern($1, virt_image_type, virt_image_type)
+	read_lnk_files_pattern($1, virt_image_type, virt_image_type)
+	read_blk_files_pattern($1, virt_image_type, virt_image_type)
+	read_chr_files_pattern($1, virt_image_type, virt_image_type)
+
+	tunable_policy(`virt_use_nfs',`
+		fs_list_nfs($1)
+		fs_read_nfs_files($1)
+		fs_read_nfs_symlinks($1)
+	')
+
+	tunable_policy(`virt_use_samba',`
+		fs_list_cifs($1)
+		fs_read_cifs_files($1)
+		fs_read_cifs_symlinks($1)
+	')
+')
+
+########################################
+## <summary>
+##	Allow domain to read virt blk image files
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`virt_read_blk_images',`
+	gen_require(`
+		attribute virt_image_type;
+	')
+
+	read_blk_files_pattern($1, virt_image_type, virt_image_type)
+')
+
+########################################
+## <summary>
+##	Allow domain to read/write virt image chr files
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`virt_rw_chr_files',`
+	gen_require(`
+		attribute virt_image_type;
+	')
+
+	rw_chr_files_pattern($1, virt_image_type, virt_image_type)
 ')
 
 ########################################
 ## <summary>
 ##	Create, read, write, and delete
-##	virt lib files.
+##	svirt cache files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
